/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var app = {
    // Application Constructor
    
initialize: function() {
    
    document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
    
    $(document).on('pagebeforeshow', '#home, #web, #contact', function (e,data) {
                   
                   $(document).off('click','.go-back').on('click', '.go-back', function () {
                                                          var target = $(this).data('target');
                                                          $.mobile.changePage( target, { transition: 'slide', reverse: true });
                                                          });
                   
                   app.initRippleFX();
                   
                   });
    
    $(document).on('swiperight', '#home, #web, #contact', function() {
                   
                   $.mobile.pageContainer.pagecontainer('change', '#home', { transition: 'slide', reverse: true });
                   
                   });
    
    $(document).off('click','.go-agenda').on('click', '.go-agenda', function () {
                                             var target = $(this).data('target');
                                             $(this).closest('.app').find('#app-content iframe').attr('src', target);
                                             });
    
},
    
    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
        this.receivedEvent('deviceready');
        //app.checkConnection();
        document.addEventListener('online', app.addIframe, false);
        document.addEventListener('offline', app.onDeviceOffline, false);
        app.addIframe();
    },
    
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var parentElement = document.getElementById(id);
    
        console.log('Received Event: ' + id);
    },
    
    // check connection
    checkConnection: function() {
        var networkState = navigator.connection.type;
        var states = {};
        states[Connection.UNKNOWN]  = 'Unknown connection';
        states[Connection.ETHERNET] = 'Ethernet connection';
        states[Connection.WIFI]     = 'WiFi connection';
        states[Connection.CELL_2G]  = 'Cell 2G connection';
        states[Connection.CELL_3G]  = 'Cell 3G connection';
        states[Connection.CELL_4G]  = 'Cell 4G connection';
        states[Connection.CELL]     = 'Cell generic connection';
        states[Connection.NONE]     = 'No network connection';
        alert('Connection type: ' + states[networkState]);
    },
    
    // Lost connection
    onDeviceOffline: function() {
        if (navigator.globalization !== undefined) {
            navigator.globalization.getLocaleName(
                                                         function (locale) {
                                                            if (locale !== undefined) {
                                                                var lang = locale.value.substring(0, 2);
                                                                var html = '';
                                                                if(lang == 'ca') {
                                                  $.mobile.pageContainer.pagecontainer('change', '#offline-ca', { transition: 'slide', reverse: true });
                                                                } else if(lang == 'es') {
                                                  $.mobile.pageContainer.pagecontainer('change', '#offline', { transition: 'slide', reverse: true });
                                                                } else {
                                                  $.mobile.pageContainer.pagecontainer('change', '#offline-en', { transition: 'slide', reverse: true });

                                                                }
                                                                document.getElementById("app").replaceWith = html;
                                                            }
                                                         },
                                                         function () {
                                                  $.mobile.pageContainer.pagecontainer('change', '#offline-en', { transition: 'slide', reverse: true });
                                                         }
                                                         );
        }
    },

    addIframe: function () {
        if (navigator.globalization !== undefined) {
            navigator.globalization.getLocaleName(
                                                         function (locale) {
                                                            if (locale !== undefined) {
                                                                var lang = locale.value.substring(0, 2);
                                                                var url = '';
                                                                if(lang == 'ca') {
                                                  $.mobile.pageContainer.pagecontainer('change', '#home-ca', { transition: 'slide', reverse: true });
                                                                } else if(lang == 'es') {
                                                  $.mobile.pageContainer.pagecontainer('change', '#home', { transition: 'slide', reverse: true });
                                                                } else {
                                                  $.mobile.pageContainer.pagecontainer('change', '#home-en', { transition: 'slide', reverse: true });
                                                                }
                                                            }
                                                         },
                                                         function () {
                                                  $.mobile.pageContainer.pagecontainer('change', '#home-en', { transition: 'slide', reverse: true });

                                                         }
                                                         );
        }
    },
    
    checkLanguage: function () {
        if (navigator.globalization !== undefined) {
            navigator.globalization.getLocaleName(
                                                        function (locale) {
                                                            if (locale !== undefined) {
                                                                alert('locale: ' + locale.value);
                                                                var lang = locale.value.substring(0, 2);
                                                  
                                                            }
                                                        },
                                                        function () {
                                                         //nothing ;
                                                        }
                                                        );
        }
    },
    
initRippleFX: function() {
    
    var $haveRipple = $('.ui-link');
    
    if ( $haveRipple.length ) {
        
        var $element = $haveRipple;
        var current, ripple, d, x, y;
        
        $element.on('click', function (e) {
                    
                    current = $(this);
                    
                    if (current.find(".ripple").length === 0) {
                    current.addClass('prepare-ripple');
                    current.prepend("<span class='ripple'></span>");
                    }
                    
                    ripple = current.find(".ripple");
                    ripple.removeClass("on-animate");
                    
                    if (!ripple.height() && !ripple.width()) {
                    
                    d = Math.max(current.outerWidth(), current.outerHeight());
                    
                    ripple.css({
                               height: d,
                               width: d
                               });
                    }
                    
                    x = e.pageX - current.offset().left - ripple.width() / 2;
                    y = e.pageY - current.offset().top - ripple.height() / 2;
                    
                    ripple.css({
                               top: y + 'px',
                               left: x + 'px'
                               }).addClass("on-animate");
                    
                    });
        
        console.log('Added ripple FX to buttons…');
        
    }
    
}
    
};

app.initialize();

FastClick.attach(document.body);
